                  %% CS_SMKL
function ypred = cs_smkl(K,Kte,label_tr,label_te,numclass)

    par.C = 1000; % regularization parameter
    par.eps = 0.001; % threshold parameter
    par.opt = 'smo'; % optimizer [libsvm, quadprog, smo]
    par.p = 1; % regularization norm
    par.tau = 1e-3; % tau parameter for SMO algorithm
        yvote = zeros(size(label_te,1),numclass);
        for i = 1 : numclass-1
            for j = i+1 : numclass
                i_idx = find(label_tr==i);
                j_idx = find(label_tr==j);
                for t=1:size(K,3)
                    tra{t}.y = [ ones(size(i_idx,1),1); -ones(size(j_idx,1),1) ];
                    tra{t}.ind = (1:size(tra{t}.y,1))';
                end
                Kt = K([i_idx;j_idx],[i_idx;j_idx],:);
                mod = cs_smkl_train(tra, par,Kt);
                mod_all{i,j} = mod;
            end
        end        
        % svm testing        
        for i = 1 : numclass-1
            for j = i+1 : numclass
                mod = mod_all{i,j};
                clear i_idx j_idx
                i_idx = find(label_tr==i);
                j_idx = find(label_tr==j);
                kt1 = Kte(:,i_idx,:);
                kt2 = Kte(:,j_idx,:);
                kt = cat(2,kt1, kt2);
                for t=1:size(Kte,3)
                    if ~isempty(mod.sup{1,t}.ind)
                        KT(:,:,t) = kt(:,mod.sup{1,t}.ind,t);
%                     else
%                         KT(:,:,t) =zeros(size( KT,1),size(KT,2));
                    end
                end           
% 
                out = cs_smkl_test(mod,KT);
                clear KT
                i_idx = find(out.dis>0);
                j_idx = find(out.dis<=0);
                yvote(i_idx,i) = yvote(i_idx,i) + 1;
                yvote(j_idx,j) = yvote(j_idx,j) + 1;
            end
        end
        [ ~, ypred ] = max(yvote');
        ypred = ypred';
end